'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TrackList = require('./TrackList');

var _TrackList2 = _interopRequireDefault(_TrackList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SpotifyPlayer = function (_React$Component) {
    _inherits(SpotifyPlayer, _React$Component);

    function SpotifyPlayer(props) {
        _classCallCheck(this, SpotifyPlayer);

        var _this = _possibleConstructorReturn(this, (SpotifyPlayer.__proto__ || Object.getPrototypeOf(SpotifyPlayer)).call(this, props));

        _this.state = {
            albumData: null,
            playerPlaceholder: '<i class="fa fa-spinner fa-spin"></i>',
            albumName: _this.props.albumName,
            artistName: _this.props.artistName
        };
        _this.fetchAlbumData = _this.fetchAlbumData.bind(_this);
        _this.fetchTracks = _this.fetchTracks.bind(_this);
        _this.firePlayingStatusChangeEvent = _this.firePlayingStatusChangeEvent.bind(_this);
        return _this;
    }

    _createClass(SpotifyPlayer, [{
        key: 'fetchAlbumData',
        value: function fetchAlbumData() {
            var xhr = new XMLHttpRequest();
            var url = 'https://api.spotify.com/v1/search';
            var that = this;
            var queryString = '?q=album:' + this.state.albumName + ' artist:' + this.state.artistName;
            queryString += '&type=album';
            xhr.open('get', url + queryString);
            xhr.setRequestHeader('Authorization', 'Bearer ' + this.props.token);
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        var response = JSON.parse(xhr.responseText);
                        if (response.albums.items.length > 0) {
                            that.fetchTracks(response.albums.items[0].id, function (data) {
                                if (data.tracks.items.length > 0) {
                                    that.setState({ albumData: data });
                                } else {
                                    that.setState({ albumData: null, playerPlaceholder: that.props.noDataFoundText });
                                }
                            });
                        } else {
                            that.setState({ albumData: null, playerPlaceholder: that.props.noDataFoundText });
                        }
                    } else {
                        that.setState({ albumData: null, playerPlaceholder: that.props.noDataFoundText });
                    }
                }
            };
            xhr.send();
        }
    }, {
        key: 'fetchTracks',
        value: function fetchTracks(albumId, callback) {
            var xhr = new XMLHttpRequest();
            var that = this;
            xhr.open('get', 'https://api.spotify.com/v1/albums/' + albumId);
            xhr.setRequestHeader('Authorization', 'Bearer ' + this.props.token);
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        var response = JSON.parse(xhr.responseText);
                        callback(response);
                    } else {
                        that.setState({ albumData: null, playerPlaceholder: that.props.noDataFoundText });
                    }
                }
            };
            xhr.send();
        }
    }, {
        key: 'firePlayingStatusChangeEvent',
        value: function firePlayingStatusChangeEvent(isPlaying, audioTrack, spotifyTrack) {
            if (isPlaying && this.props.onTrackPlayed) {
                this.props.onTrackPlayed(audioTrack, spotifyTrack);
            } else if (!isPlaying && this.props.onTrackPaused) {
                this.props.onTrackPaused(audioTrack, spotifyTrack);
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.token === null) {
                alert('A valid access token is needed to access spotify API');
                return;
            }
            this.fetchAlbumData();
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(newProps) {
            if (newProps.albumName !== this.props.albumName || newProps.artistName !== this.props.artistName) {
                this.setState({ artistName: newProps.artistName, albumName: newProps.albumName }, this.fetchAlbumData);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var playlistHeader = function () {
                if (this.props.showHeader) {
                    return _react2.default.createElement(
                        'div',
                        { className: 'media' },
                        _react2.default.createElement(
                            'div',
                            { className: 'media-left' },
                            _react2.default.createElement(
                                'a',
                                { href: this.state.albumData.external_urls.spotify },
                                _react2.default.createElement('img', {
                                    alt: 'cover image',
                                    className: 'media-object',
                                    height: '64',
                                    src: this.state.albumData.images[0].url,
                                    width: '64'
                                })
                            )
                        ),
                        _react2.default.createElement(
                            'div',
                            { className: 'media-body' },
                            _react2.default.createElement(
                                'h4',
                                { className: 'media-heading' },
                                this.state.albumData.name
                            ),
                            this.state.albumData.release_date
                        )
                    );
                }
                return null;
            }.bind(this);
            if (this.state.albumData === null) {
                return _react2.default.createElement(
                    'section',
                    { className: 'spotify-player' },
                    _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.state.playerPlaceholder } })
                );
            } else {
                return _react2.default.createElement(
                    'section',
                    { className: 'spotify-player' },
                    playlistHeader(),
                    _react2.default.createElement(_TrackList2.default, {
                        listGroupClassName: this.props.listGroupClassName,
                        listGroupItemBadgeClassName: this.props.listGroupItemBadgeClassName,
                        listGroupItemClassName: this.props.listGroupItemClassName,
                        previewWarningText: this.props.previewWarningText,
                        tracks: this.state.albumData.tracks.items,
                        updateTrackPlayingStatus: this.firePlayingStatusChangeEvent
                    })
                );
            }
        }
    }]);

    return SpotifyPlayer;
}(_react2.default.Component);

SpotifyPlayer.propTypes = {
    albumName: _react2.default.PropTypes.string.isRequired,
    artistName: _react2.default.PropTypes.string.isRequired,
    listGroupClassName: _react2.default.PropTypes.string,
    listGroupItemBadgeClassName: _react2.default.PropTypes.string,
    listGroupItemClassName: _react2.default.PropTypes.string,
    noDataFoundText: _react2.default.PropTypes.string,
    onTrackPaused: _react2.default.PropTypes.func,
    onTrackPlayed: _react2.default.PropTypes.func,
    previewWarningText: _react2.default.PropTypes.string,
    showHeader: _react2.default.PropTypes.bool,
    token: _react2.default.PropTypes.string
};
SpotifyPlayer.defaultProps = {
    listGroupClassName: 'list-group',
    listGroupItemBadgeClassName: 'badge',
    listGroupItemClassName: 'list-group-item',
    noDataFoundText: 'No data found',
    onTrackPaused: undefined,
    onTrackPlayed: undefined,
    previewWarningText: 'Only 30 seconds preview',
    showHeader: true,
    token: 'required to work' //https://developer.spotify.com/web-api/
};

module.exports = SpotifyPlayer;