'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Track = function (_React$Component) {
    _inherits(Track, _React$Component);

    function Track(props) {
        _classCallCheck(this, Track);

        var _this = _possibleConstructorReturn(this, (Track.__proto__ || Object.getPrototypeOf(Track)).call(this, props));

        _this.state = {
            isPlaying: false
        };
        _this.audio = new Audio();
        _this.getDuration = _this.getDuration.bind(_this);
        _this.playTrack = _this.playTrack.bind(_this);
        return _this;
    }

    _createClass(Track, [{
        key: 'getDuration',
        value: function getDuration(ms) {
            var min = ms / 1000 / 60 << 0;
            var sec = ms / 1000 % 60;
            return Math.round(min, -2) + ':' + (Math.round(sec, -2) < 10 ? '0' + Math.round(sec, -2) : Math.round(sec, -2));
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {

            this.audio.setAttribute('src', this.props.track.preview_url);
            this.audio.load();
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(newProps) {
            if (newProps.track.preview_url !== this.props.track.preview_url) {
                this.audio.setAttribute('src', newProps.track.preview_url);
                this.audio.load();
            }
        }
    }, {
        key: 'playTrack',
        value: function playTrack(event) {
            event.preventDefault();
            if (this.audio.paused) {
                this.setState({ isPlaying: true }, function () {
                    this.audio.play();
                    this.props.onPlayingStatusChange(true, this.audio, this.props.track);
                    this.audio.addEventListener('ended', function () {
                        this.setState({ isPlaying: false });
                        this.props.onPlayingStatusChange(false, this.audio, this.props.track);
                    });
                });
            } else {
                this.audio.pause();
                this.setState({ isPlaying: false }, function () {
                    this.props.onPlayingStatusChange(false, this.audio, this.props.track);
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var playButtonClassNames = this.state.isPlaying ? 'fa fa-pause' : 'fa fa-play';
            var playButtonStyle = { cursor: 'default' };
            return _react2.default.createElement(
                'div',
                { className: this.props.listGroupItemClassName, onClick: this.playTrack },
                _react2.default.createElement(
                    'a',
                    { href: '#',
                        style: playButtonStyle,
                        title: this.props.tooltip
                    },
                    this.props.track.track_number,
                    '. ',
                    this.props.track.name,
                    ' (',
                    this.getDuration(this.props.track.duration_ms),
                    ')'
                ),
                _react2.default.createElement(
                    'span',
                    { className: this.props.listGroupItemBadgeClassName },
                    _react2.default.createElement('i', {
                        className: playButtonClassNames
                    })
                )
            );
        }
    }]);

    return Track;
}(_react2.default.Component);

Track.propTypes = {
    listGroupItemBadgeClassName: _react2.default.PropTypes.string,
    listGroupItemClassName: _react2.default.PropTypes.string,
    onPlayingStatusChange: _react2.default.PropTypes.func, //handler on playing status change, function(isPlaying, audioTrack, spotifyTrack),
    tooltip: _react2.default.PropTypes.string.isRequired,
    track: _react2.default.PropTypes.object.isRequired
};

Track.defaultProps = {
    onPlayingStatusChange: undefined
};
module.exports = Track;