'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TrackList = function (_React$Component) {
    _inherits(TrackList, _React$Component);

    function TrackList(props) {
        _classCallCheck(this, TrackList);

        var _this = _possibleConstructorReturn(this, (TrackList.__proto__ || Object.getPrototypeOf(TrackList)).call(this, props));

        _this.trackChangedStatus = _this.trackChangedStatus.bind(_this);
        return _this;
    }

    _createClass(TrackList, [{
        key: 'trackChangedStatus',
        value: function trackChangedStatus(isPlaying, audioTrack, spotifyTrack) {
            this.props.updateTrackPlayingStatus(isPlaying, audioTrack, spotifyTrack);
        }
    }, {
        key: 'render',
        value: function render() {
            var trackNodesData = this.props.tracks.map(function (track, index) {
                return _react2.default.createElement(_Track2.default, {
                    key: index,
                    listGroupItemBadgeClassName: this.props.listGroupItemBadgeClassName,
                    listGroupItemClassName: this.props.listGroupItemClassName,
                    onPlayingStatusChange: this.trackChangedStatus,
                    tooltip: this.props.previewWarningText,
                    track: track
                });
            }.bind(this));
            return _react2.default.createElement(
                'div',
                { className: this.props.listGroupClassName },
                trackNodesData
            );
        }
    }]);

    return TrackList;
}(_react2.default.Component);

TrackList.propTypes = {
    listGroupItemBadgeClassName: _react2.default.PropTypes.string,
    listGroupClassName: _react2.default.PropTypes.string,
    listGroupItemClassName: _react2.default.PropTypes.string,
    previewWarningText: _react2.default.PropTypes.string,
    tracks: _react2.default.PropTypes.array,
    updateTrackPlayingStatus: _react2.default.PropTypes.func
};

TrackList.defaultProps = {
    tracks: [],
    updateTrackPlayingStatus: undefined
};
module.exports = TrackList;